package sun.reflect;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Constructor;

class BootstrapConstructorAccessorImpl extends ConstructorAccessorImpl
{
    private final Constructor<?> constructor;
    
    BootstrapConstructorAccessorImpl(Constructor<?> constructor) {
        this.constructor = constructor;
    }
    
    @Override
    public Object newInstance(Object[] array) throws IllegalArgumentException, InvocationTargetException {
        try {
            return UnsafeFieldAccessorImpl.unsafe.allocateInstance(this.constructor.getDeclaringClass());
        }
        catch (InstantiationException target) {
            throw new InvocationTargetException(target);
        }
    }
}
